rem edit these
set STATION=G8GTZ
set STATION_DESC=via QO-100, IO91KF
set NAME=Noel

rem enter TS bitrate here based on calculations from http://www.satbroadcasts.com/DVB-S_Bitrate_and_Bandwidth_Calculator.html 
rem use Netto TS bitrate 3 digits only

rem set TS=%1

set TS=440


set AUDIO_RATE=32

rem SET OUTPUT_IP= Portsdown or Pluto (Portsdown port = 10000
SET OUTPUT_IP=192.168.1.177:10000
 
set /a TS_NO_AUDIO=%TS%-%AUDIO_RATE%
set /a VIDEO_RATE=%TS_NO_AUDIO% * 75 / 100 
set /a BUFSIZE=%VIDEO_RATE% *5 / 10 

set /a TSBITRATE=%TS% * 1000 
echo -------------------------
echo TS rate: %TS% kbit
echo Video: %VIDEO_RATE% kbit
echo Audio: %AUDIO_RATE% kbit

rem -----------------------------------------------------------------------
rem this next section is a caption generator that does not seem to work!


rem HEIGHT -65
set TEXTY=1030
rem set TEXTY=655
set /a TEXTYY=%TEXTY% +22
set TEXTCOL=0x33CCFFEE
set T2_SIZE=50
set DATECOL=0xFFCC00FF

set TEXT_CMD=-vf "drawtext=fontfile='hemi.ttf':text=%%{gmtime\\:%%d %%b %%Y %%X}:x=10:y=10:fontsize=%T2_SIZE%:fontcolor=%DATECOL%:shadowcolor=0x00007f9f:shadowx=2:shadowy=2, drawtext=fontfile='hemi.ttf':text='%STATION%':x=25:y=%TEXTY%:fontsize=80:fontcolor=%TEXTCOL%:shadowcolor=0x00007f9f:shadowx=2:shadowy=2, drawtext=fontfile='hemi.ttf':text='%STATION_DESC%':x=320:y=%TEXTYY%:fontsize=%T2_SIZE%:fontcolor=%TEXTCOL%:shadowcolor=0x00007f9f:shadowx=2:shadowy=2"
echo %TEXT_CMD%
rem without time 
set TEXT_CMD=-vf "drawtext=fontfile='hemi.ttf':text='%STATION%':x=25:y=%TEXTY%:fontsize=50:fontcolor=%TEXTCOL%:shadowcolor=0x00007f9f:shadowx=2:shadowy=2, drawtext=fontfile='hemi.ttf':text='via QO-100, IO91KF':x=200:y=%TEXTYY%:fontsize=20:fontcolor=%TEXTCOL%:shadowcolor=0x00007f9f:shadowx=2:shadowy=2"

rem 43240 udp
set OUTPUT_STREAM=-f mpegts -muxrate %TS%k  -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256 -streamid 1:257 -metadata service_provider="%STATION%" -metadata service_name="%STATION% %NAME%" -y "udp://%OUTPUT_IP%?pkt_size=43240&bitrate=%TSBITRATE%"

rem ----------------------------------------------------------------------------

set VIDEO_DEVICE="vMix Video"

rem set this to match resolution of Vmix external output
rem set RESOLUTION=640x480
rem set RESOLUTION=730x410
rem set RESOLUTION=864x480
rem set RESOLUTION=768x480
rem set RESOLUTION=720x576
set RESOLUTION=1280x720
rem set RESOLUTION=1920x1080

set FPS=25

set AUDIO_SOURCE="vMix Audio"
set AUDIO_PARAMS=-af "highpass=f=250, lowpass=f=4000" -acodec aac -aac_coder twoloop -aac_pns disable -ar 22050 -ac 1

rem set AUDIO_PARAMS=-af "highpass=f=250, lowpass=f=4000" -acodec ac3 -ar 22050 -ac 1
rem set AUDIO_PARAMS=-af "highpass=f=250, lowpass=f=4000" -acodec mp2 -ar 22050 -ac 1
rem set AUDIO_PARAMS=-af "highpass=f=250, lowpass=f=4000" -acodec aac -aac_coder twoloop -aac_pns disable -profile aac_ltp -ar 22050 -ac 1
        
rem hq
set VIDEO_CODEC=-pix_fmt yuv444p16le -vcodec hevc_nvenc -preset hq -profile:v main10 -cbr 1 -rc cbr_hq 
rem -forced-idr 1


set VIDEO_CODEC=-pix_fmt yuv420p -vcodec hevc_nvenc -preset llhq -profile:v main -cbr 1 -rc cbr_hq -forced-idr 1

rem set VIDEO_CODEC=-pix_fmt rgb0 -vcodec hevc_nvenc -preset slow -profile:v main -cbr 1 -rc cbr_hq -forced-idr 1

set VIDEO_CODEC=-pix_fmt yuv444p16le  -vcodec hevc_nvenc -preset slow -profile:v main10 -rc-lookahead 25 -spatial_aq 1 -cbr 1 -rc cbr_hq -surfaces 4

set VIDEO_CODEC=-pix_fmt yuv420p -vcodec hevc_nvenc -preset slow -profile:v main -rc-lookahead 15 -spatial_aq 1 -cbr 1 -rc cbr_hq -surfaces 4

rem compatible with hardware decoders
rem set VIDEO_CODEC=-pix_fmt yuv420p -vcodec hevc_nvenc -preset llhq -profile:v main -cbr 1 -rc cbr_hq -forced-idr 1

rem H264
rem set VIDEO_CODEC=-pix_fmt yuv420p -vcodec nvenc_h264 -preset llhq -profile:v main -cbr 1 -rc cbr_hq -forced-idr 1


ffmpeg  -f dshow -i video=%VIDEO_DEVICE% -f dshow -i audio=%AUDIO_SOURCE% -sample_rate 22050 -audio_buffer_size 100k %FILTERS% -s %RESOLUTION% -r %FPS% %VIDEO_CODEC% -b:v %VIDEO_RATE%k -minrate:v %VIDEO_RATE%k -maxrate:v %VIDEO_RATE%k -bufsize:v %BUFSIZE%k -ab %AUDIO_RATE%k %AUDIO_PARAMS% %TEXT_CMD% %OUTPUT_STREAM%
